import javax.swing.*;
import java.awt.*;
import java.awt.event.*;       
import java.applet.Applet;


public class MouseCircle2 extends Applet {

    int x, y;
    String key = "";

    public void init() {
        addMouseListener( new MouseAdapter() {
                public void mousePressed(MouseEvent event) {
                    x = event.getX();
                    y = event.getY();
                    repaint();
		    requestFocus();
                }
            } );

        addKeyListener( new KeyAdapter() {
                public void keyPressed(KeyEvent e) {
                    char c = e.getKeyChar();
                    int  k = e.getKeyCode();
                    int modifiers = e.getModifiers();

                    key = KeyEvent.getKeyModifiersText(modifiers) 
                        + " " 
                        + KeyEvent.getKeyText(k)
                        + "   (" + c + ")";
                    repaint();
                }
            } );
            
    }
    
    public void paint( Graphics g ) {
        int width = getSize().width;
        int height = getSize().height;
        int dx = width/10;
        int dy = height/10;

        g.setColor( Color.black );
        g.fillRect( 0, 0, width, height );
        g.setColor( Color.blue );
        g.fillOval( x-dx, y-dy, 2*dx, 2*dy );

        g.setColor( Color.red );
        g.drawString( key, 50, 50 );
    }

}
