import java.awt.*;
import java.awt.event.*;       
import java.applet.Applet;


public class MouseCircle1a extends Applet
    implements MouseListener {

    int x, y;

    public void init() {
        addMouseListener(this);
    }
    
    public void paint( Graphics g ) {
        int width = getSize().width;
        int height = getSize().height;
        int dx = width/10;
        int dy = height/10;

        g.setColor( Color.black );
        g.fillRect( 0, 0, width, height );
        g.setColor( Color.blue );
        g.fillOval( x-dx, y-dy, 2*dx, 2*dy );
    }



    /**
      * MouseListener Interface 
      **/
    public void mousePressed(MouseEvent event) {
        x = event.getX();
        y = event.getY();
        repaint();
    }
    
    // do-nothing methods
    public void mouseReleased(MouseEvent event) {}
    public void mouseClicked(MouseEvent event) {}
    public void mouseEntered(MouseEvent event) {}
    public void mouseExited(MouseEvent event) {}
    
}
