import java.awt.*;
import java.awt.event.*;       
import java.applet.Applet;


public class MouseCircle1b extends Applet {

    int x, y;

    public void init() {
        addMouseListener( new MouseAdapter() {
                public void mousePressed(MouseEvent event) {
                    x = event.getX();
                    y = event.getY();
                    repaint();
                }
            } );
    }
    
    public void paint( Graphics g ) {
        int width = getSize().width;
        int height = getSize().height;
        int dx = width/10;
        int dy = height/10;

        g.setColor( Color.black );
        g.fillRect( 0, 0, width, height );
        g.setColor( Color.blue );
        g.fillOval( x-dx, y-dy, 2*dx, 2*dy );
    }

}
